OIDC User Info
GET
userinfo
Retrieves the profile information of an authorizing end user in a OIDC-compliant three-legged context.
Resource Information
| Method and URI | GET https://api.aps.autodesk.com/userinfo (see API Basics for legacy endpoint support) |
| Authentication Context | user context required |
| Required OAuth Scopes | openid (mandatory). Additional scopes control which fields are returned. Most requests need openid profapi:core-std-profile:read. See Custom Scopes for all available scopes and field-level access details. |
| Data Format | JSON |
| Rate Limit | 500 calls per minute. For more information, see User Profile Rate Limits. |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is obtained via a three-legged OAuth flow. |
* Required
Response
HTTP Status Code Summary
| 200 OK | Information about the currently logged in user was successfully returned. |
| 400 Bad Request | The server was unable to process the request. The syntax of the request may be malformed or may be missing a required parameter. Do not repeat the request without fixing the issue. The response body may indicate what is wrong with the request. |
| 401 Unauthorized | The access token is invalid. It may have either expired or may not be a three-legged access token. Please verify the token and retry the request. |
| 429 Too Many Requests | Rate limit exceeded; wait some time before retrying. |
| 403 Forbidden | The request was successfully validated but lacked required permission. Please verify your credentials and permissions and retry the request. |
| 500 Internal Server Error | An unknown server-side error occurred. Please try again later. If the problem persists, please contact support. |
Response
Body Structure (200)
Expand all
| sub string | The ID by which APS uniquely identifies the user. |
| name string | The full name of the user. |
| given_name string | The given name or first name of the user. |
| family_name string | The surname or last name of the user. |
| preferred_username string | The username by which the user prefers to be addressed. |
| email string | The email address of the user. |
| email_verified boolean | true: The user’s preferred email address is verified; false: The user’s preferred email address is not verified. |
| profile string | The URL of the profile page of the user. |
| picture string | The URL of the profile picture of the user. |
| locale string | The preferred language settings of the user. This setting is typically specified as a combination of the ISO 639 language code in lower case, and the ISO 3166 country code in upper case, separated by a dash character. For example en-US. |
| updated_at int | The time the user’s information was most recently updated, represented as a Unix timestamp. |
| is_twofa_enabled boolean | true: Two-factor authentication is enabled for this user; false: Two-factor authentication is not enabled for this user. |
| country_code string | The ISO 3166 country code that was assigned to the user when their profile was created. |
| address object | A JSON object containing information of the postal address of the user. |
| street_address string | The street address part of the address. Can contain the house number, street name, postal code, and so on. New lines are represented as \n. |
| locality string | The city or locality part of the address. |
| region string | The state, province, prefecture, or region part of the address. |
| postal_code string | The zip code or postal code part of the address. |
| country string | The country name part of the address. |
| phone_number string | The phone number by which the user prefers to be contacted. |
| phone_number_verified boolean | true: The phone number is verified; false: The phone number is not verified. |
| ldap_enabled boolean | true : Single sign-on using Lightweight Directory Access Protocol (LDAP) is enabled for this user.
|
| ldap_domain string | The domain name used by the LDAP server for user authentication. null, if ldap_enabled is false. |
| job_title string | The job title of the user as specified in the user’s profile. |
| industry string | The industry the user works in, as specified in the user’s profile. |
| industry_code string | A code that corresponds to the industry. |
| about_me string | A short description written by the user to introduce themselves, as specified in the user’s profile. |
| language string | The ISO 639 language code of the preferred language of the user. |
| company string | The company that the user works for, as specified in the user’s profile. |
| created_date string | The time the user profile was created, represented as a Unix timestamp. |
| last_login_date string | The time the user most recently signed-in to APS successfully, represented as a Unix timestamp. |
| eidm_guid string | An ID to uniquely identify the user. For most users this will be the same as sub. However, for users profiles created on the now retired EIDM system eidm_guid will be different from sub. |
| opt_in boolean | true : The user has agreed to receive marketing information.
|
| social_userinfo_list array: object | An array of objects, where each object represents a social media account that can be used to verify the user’s identity. |
| socialUserId string | The ID of the user within the social media platform. |
| providerId string | The ID of the social media platform. |
| providerName string | The name of the social media platform. |
| twofa_type string | The type of two-factor authentication enabled for the user. Possible values: Phone, Email, Authenticator. |
| contact_mode string | The mode of contact for two-factor authentication. Possible values: SMS, Email, Authenticator. |
| user_source_type string | The source type of the user where the value indicates how the user was created. Possible values: Identity, EIDM, Rest API, Ldap/Enterprise, Test User, Provisioned, Ldap Provisioned. |
| user_thumbnails object | An array of key-value pairs for image URLs of available thumbnail sizes of the user’s profile picture. The key is named sizeX<NUMBER> where <NUMBER> is the width and height of the thumbnail, in pixels. The corresponding value is the unique, secure, pre-signed & short-lived URL pointing to the thumbnail. For example, sizeX120 would contain the URL for the 120x120 pixel thumbnail. New Image URL Pattern: https://<domain-name>/<obfuscated-elements>/x<size>.jpg?t=<token-value>. However, please note that the default image URL path will remain unchanged. Default Image URL Pattern: https://<domain-name>/default/user_x<size>.png. |
| sizeX20 string | Represents the image thumbnail of sizeX20. |
| sizeX40 string | Represents the image thumbnail of sizeX40. |
| sizeX50 string | Represents the image thumbnail of sizeX50. |
| sizeX58 string | Represents the image thumbnail of sizeX58. |
| sizeX80 string | Represents the image thumbnail of sizeX80. |
| sizeX120 string | Represents the image thumbnail of sizeX120. |
| sizeX160 string | Represents the image thumbnail of sizeX160. |
| sizeX176 string | Represents the image thumbnail of sizeX176. |
| sizeX240 string | Represents the image thumbnail of sizeX240. |
| sizeX360 string | Represents the image thumbnail of sizeX360. |
Example
This example demonstrates successful retrieval of a user profile.
Request
curl --location 'https://api.aps.autodesk.com/userinfo' \
--header 'Authorization: Bearer eyJh...' \
const axios = require('axios');
const config = {
method: 'get',
url: 'https://api.aps.autodesk.com/userinfo',
headers: {
Authorization: 'Bearer <ACCESS_TOKEN>'
}
};
(async () => {
try {
const response = await axios(config);
console.log(JSON.stringify(response.data));
} catch (error) {
console.error(error);
}
})();
Show More
Unirest.setTimeouts(0, 0);
HttpResponse<String> response = Unirest.post("https://api.aps.autodesk.com/userinfo")
.header("Authorization", "Bearer <ACCESS_TOKEN>")
.header("Content-Type", "application/json")
.asString();
Response
{
"sub": "ABCDEFGH",
"name": "First Last",
"given_name": "First",
"family_name": "Last",
"preferred_username": "username",
"email": "test@test.com",
"email_verified": true,
"alternate_email": "test.alternate@test.com",
"profile": "https://profile.autodesk.com",
"picture": "https://images.profile.autodesk.com/<hash>/x120.jpg?t=<generated-token>",
"locale": "en-US",
"updated_at": 1662583480,
"is_twofa_enabled": false,
"country_code": "US",
"address": {
"street_address": "testaddress1\n",
"locality": "testcity",
"region": "",
"postal_code": "",
"country": "US"
},
"phone_number": "+1 1234567890 #123",
"phone_number_verified": false,
"ldap_enabled": true,
"ldap_domain": "autodesk.com",
"job_title": "3D generalist",
"industry": "IT/Software development",
"industry_code": "NoGroupOther",
"about_me": "I'm completing a test right now.",
"language": "en",
"company": "Autodesk",
"created_date": "2017-12-11T20:54:18Z",
"last_login_date": "2020-05-10T04:00:29Z",
"eidm_guid": "ABCDEFGH",
"opt_in": false,
"social_userinfo_list": [
{
"socialUserId": "test.social_userid",
"providerId": "test1.uid",
"providerName": "Google"
}
],
"twofa_type": "Phone",
"contact_mode": "SMS",
"user_source_type": "Provisioned",
"user_thumbnails": {
"sizeX20": "https://images.profile-dev.autodesk.com/default/user_X20.png",
"sizeX40": "https://images.profile-dev.autodesk.com/default/user_X40.png",
"sizeX50": "https://images.profile-dev.autodesk.com/default/user_X50.png",
"sizeX58": "https://images.profile-dev.autodesk.com/default/user_X58.png",
"sizeX80": "https://images.profile-dev.autodesk.com/default/user_X80.png",
"sizeX120": "https://images.profile-dev.autodesk.com/default/user_X120.png",
"sizeX160": "https://images.profile-dev.autodesk.com/default/user_X160.png",
"sizeX176": "https://images.profile-dev.autodesk.com/default/user_X176.png",
"sizeX240": "https://images.profile-dev.autodesk.com/default/user_X240.png",
"sizeX360": "https://images.profile-dev.autodesk.com/default/user_X360.png"
}
}
Show More